"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.handle = void 0;
var labels_1 = require("./labels");
function sleep(ms) {
    return new Promise(function (resolve) { return setTimeout(resolve, ms); });
}
function handle(context, requiredLabels, waitTimeMs) {
    return __awaiter(this, void 0, void 0, function () {
        var labels, issueNumber, owner, repo, logger, _loop_1, _i, requiredLabels_1, l;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if ("pull_request" === context.event) {
                        labels = context.payload.pull_request.labels;
                    }
                    else {
                        labels = context.payload.issue.labels;
                    }
                    issueNumber = context.issue().number;
                    owner = context.issue().owner;
                    repo = context.issue().repo;
                    logger = context.log.child({
                        owner: owner,
                        repo: repo,
                        issue: issueNumber,
                        app: "probot-require-label",
                    });
                    if (!!context.payload.label) return [3 /*break*/, 2];
                    // wait as issue was just opened
                    logger.debug("waiting " + waitTimeMs + "ms");
                    return [4 /*yield*/, sleep(waitTimeMs)];
                case 1:
                    _a.sent();
                    // labels are now stale
                    labels = [];
                    _a.label = 2;
                case 2:
                    if (!(labels.length === 0)) return [3 /*break*/, 4];
                    // refresh labels from github
                    return [4 /*yield*/, context.github.issues
                            .listLabelsOnIssue({
                            repo: repo,
                            owner: owner,
                            issue_number: issueNumber,
                        })
                            .then(function (resp) {
                            labels = resp.data;
                        })
                            .catch(function (err) {
                            throw new Error("Couldn't list labels for issue: " + issueNumber + ", error: " + err);
                        })];
                case 3:
                    // refresh labels from github
                    _a.sent();
                    logger.debug("refreshed labels: " + labels);
                    _a.label = 4;
                case 4:
                    _loop_1 = function (l) {
                        var regex;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    regex = new RegExp(l.regex);
                                    if (!(labels_1.hasMissingLabel(labels, l.missingLabel) === false &&
                                        labels_1.hasMatchingLabel(labels, regex) === false)) return [3 /*break*/, 2];
                                    return [4 /*yield*/, context.github.issues
                                            .addLabels({
                                            owner: owner,
                                            repo: repo,
                                            issue_number: issueNumber,
                                            labels: [l.missingLabel],
                                        })
                                            .catch(function (err) {
                                            throw new Error("Couldn't add labels for issue: " + issueNumber + ", error: " + err);
                                        })];
                                case 1:
                                    _a.sent();
                                    logger.debug("added labels " + l.missingLabel);
                                    _a.label = 2;
                                case 2:
                                    if (!(labels_1.hasMissingLabel(labels, l.missingLabel) &&
                                        labels_1.hasMatchingLabel(labels, regex))) return [3 /*break*/, 4];
                                    return [4 /*yield*/, context.github.issues
                                            .removeLabel({
                                            owner: owner,
                                            repo: repo,
                                            issue_number: issueNumber,
                                            name: l.missingLabel,
                                        })
                                            .catch(function (err) {
                                            throw new Error("Couldn't remove label: " + l.missingLabel + " for issue: " + issueNumber + ", error: " + err);
                                        })];
                                case 3:
                                    _a.sent();
                                    logger.debug("removed labels: " + l.missingLabel);
                                    _a.label = 4;
                                case 4: return [2 /*return*/];
                            }
                        });
                    };
                    _i = 0, requiredLabels_1 = requiredLabels;
                    _a.label = 5;
                case 5:
                    if (!(_i < requiredLabels_1.length)) return [3 /*break*/, 8];
                    l = requiredLabels_1[_i];
                    return [5 /*yield**/, _loop_1(l)];
                case 6:
                    _a.sent();
                    _a.label = 7;
                case 7:
                    _i++;
                    return [3 /*break*/, 5];
                case 8: return [2 /*return*/];
            }
        });
    });
}
exports.handle = handle;
//# sourceMappingURL=handler.js.map